"use strict";
this.name = "GET_HUD";
this.author = "Reval";
this.licence = "CC BY-NC-SA 4.0";


this.startUp = function() {
	player.ship.hud = this.name + ".plist";
}


this.startUpComplete = function() {
	player.ship.hud = this.name + ".plist";
}


this.playerBoughtNewShip = function(ship, price) {
	player.ship.hud = this.name + ".plist";
}


this.shipWillLaunchFromStation = function() {
	player.ship.hud = this.name + ".plist";
	if(!this.$Timer) this.$Timer = new Timer(this,this._updateSpeed.bind(this),0,0.25);
	if(!this.$Timer1) this.$Timer1 = new Timer(this,this._showWeps.bind(this),0,0.25);
	this._listGoods();
}


this.guiScreenChanged = function(to, from) {
	if (from == "GUI_SCREEN_MARKET") this._listGoods();
}


this._centeredText = function(txt, width) {
	var t = ""+txt; // force to string, else txt.length is undefined for numbers
	var w = width / 2;
	while( t && t.length < w ) { // for fixed width font in setCustomHUDDial
		t = " " + t;
	}
	return(t);
}


this._updateSpeed = function () {
	var p = player.ship;
	if((!p) || (!p.isValid)) return; // player died

	var setd = p.setCustomHUDDial;
	if (setd) {
		var sp = p.speed;
		sp = this._centeredText(sp.toFixed(1), 28); // default width
		setd("shipSpeed", sp);
	}
}


// output goods list to HUD
this._listGoods = function() {
	var p = player.ship;
	if((!p) || (!p.isValid)) return; // player died

	var setd = p.setCustomHUDDial;
	if (setd) {
		var goods = this._goodsList();
		setd("goodsList", goods);
	}
}


// list commodities in ship's hold
this._goodsList = function() {
	var result = "";
	for (var i=0; i<manifest.list.length; i++) {
		var q = manifest.list[i].commodity;
		if (q) result += q + "  ";
	}	
	if (result=="") result = "EMPTY";
	return result;
}


// weapons online indicator
this._showWeps = function() {
	var p = player.ship;
	if((!p) || (!p.isValid)) return; // player died

	var setd = p.setCustomHUDDial;
	if (setd) {
		var weps = "";
		if (p.weaponsOnline) weps="W";
		setd("showWeapons", weps);
	}
}


